<script lang="ts">
  import { onDestroy } from 'svelte';

  import { isDarkMode, noOp, upload } from '@/utils';

  export let file: File | null = null;
  //eslint-disable-next-line @typescript-eslint/no-explicit-any
  export let uploadExtras: Record<string, any> | null = null;
  export let contentType: string | null = null;

  let authType: 'none' | 'basic' | 'bearer' = 'none';
  let showSecret = false;
  let username = '';
  let password = '';
  let token = '';
  let endpoint = '';
  let requestStatus = 'none';
  /**
   * Upload the file
   * @returns {void}
   */
  const _upload = (): void => {
    if (
      (file !== null && file !== undefined) ||
      (uploadExtras !== null && uploadExtras != undefined)
    ) {
      const headers: Record<string, string> = {};
      if (authType == 'basic') {
        headers['Authorization'] = `Basic ${window.btoa(`${username}:${password}`)}`;
      } else if (authType == 'bearer') {
        headers['Authorization'] = `Bearer ${token}`;
      }
      requestStatus = 'pending';
      upload(endpoint, headers, file, uploadExtras, contentType).then(({ success }) => {
        requestStatus = success ? 'success' : 'error';
      });
    }
  };
  /**
   * On authentication type change
   * @param {Event} e The triggered event
   * @returns {void}
   */
  const onAuthSelectChange = (e: Event): void => {
    if (e.target) {
      const selectEl = e.target as HTMLSelectElement;
      if (selectEl && ['none', 'basic', 'bearer'].includes(selectEl.value)) {
        authType = selectEl.value as 'none' | 'basic' | 'bearer';
        updateButton();
      }
    }
  };
  /**
   * On password / token change
   * @param {Event} e The triggered event
   * @returns {void}
   */
  const onSecretChange = (e: Event): void => {
    if (e.target) {
      const inputEl = e.target as HTMLInputElement;
      if (inputEl) {
        if (authType === 'basic') {
          password = inputEl.value;
        } else if (authType === 'bearer') {
          token = inputEl.value;
        }
        updateButton();
      }
    }
  };
  /**
   * On username change
   * @param {Event} e The triggered event
   * @returns {void}
   */
  const onUsernameChange = (e: Event): void => {
    if (e.target) {
      const inputEl = e.target as HTMLInputElement;
      if (inputEl) {
        username = inputEl.value;
        updateButton();
      }
    }
  };
  /**
   * On endpoint change
   * @param {Event} e The triggered event
   * @returns {void}
   */
  const endpointChange = (e: Event): void => {
    if (e.target) {
      const inputEl = e.target as HTMLInputElement;
      if (inputEl) {
        endpoint = inputEl.value;
        updateButton();
      }
    }
  };
  /**
   * Update the submit button disabled property
   * @returns {void}
   */
  const updateButton = (): void => {
    const button = document.querySelector('button');
    if (button) {
      if (canSubmit()) {
        button.removeAttribute('disabled');
      } else {
        button.setAttribute('disabled', 'true');
      }
    }
    if (requestStatus != 'none') {
      requestStatus = 'none';
    }
  };
  /** Check if the form can be submitted
   * @returns {boolean}
   */
  const canSubmit = (): boolean => {
    if (requestStatus != 'none') {
      return false;
    }
    if (endpoint.length < 10) {
      return false;
    }
    if (!endpoint.startsWith('http://') && !endpoint.startsWith('https://')) {
      console.log('Endpoint must start with http:// or https://');
      return false;
    }
    if (authType === 'none') {
      return true;
    } else if (authType === 'basic') {
      return username.length > 0 && password.length > 0;
    } else if (authType === 'bearer') {
      return token.length > 0;
    }
    return false;
  };
  /**
   * On destroy hook
   * @returns {void}
   */
  onDestroy(() => {
    authType = 'none';
    showSecret = false;
    username = '';
    password = '';
    token = '';
    endpoint = '';
  });
</script>

<div class="submit-content">
  <div>
    <h2>Upload</h2>
    <p>Upload your file to a server</p>
  </div>
  <div style="width:100%;flex:1">
    <div style="display: flex;flex-direction:column">
      {#if file}
        <div>
          <label for="file-name">File:</label>
          <input
            style="width: 100%;margin-bottom:10px"
            type="text"
            name="file-name"
            value={file.name}
            disabled
            readonly
          />
        </div>
      {/if}
      <div>
        <label for="server-url">Endpoint URL:</label>
        <input
          style="width: 100%;margin-bottom:10px"
          type="text"
          name="server-url"
          value={endpoint}
          on:keyup={endpointChange}
          placeholder="Endpoint URL"
        />
      </div>
      <div>
        <label for="auth-select">Authorization:</label>
        <select
          style="width: 100%;margin-bottom:10px"
          name="auth-select"
          on:change={onAuthSelectChange}
        >
          <option value="none">None</option>
          <option value="basic">Basic</option>
          <option value="bearer">Bearer</option>
        </select>
        {#if authType === 'basic'}
          <div>
            <label for="username">Username:</label>
            <input
              style="width: 100%;margin-bottom:10px"
              type="text"
              name="username"
              placeholder="Username"
              on:keyup={onUsernameChange}
              value={username}
            />
          </div>
        {/if}
        {#if authType === 'basic' || authType === 'bearer'}
          <div>
            <label for="secret">{authType === 'basic' ? 'Password' : 'Token'}:</label>
            <div>
              <input
                style="width: 100%;margin-bottom:10px"
                type={showSecret ? 'text' : 'password'}
                name="secret"
                placeholder={authType === 'basic' ? 'Password' : 'Token'}
                value={authType === 'basic' ? password : token}
                on:keyup={onSecretChange}
              />
              <i
                class="fa {showSecret ? 'fa-eye-slash' : 'fa-eye'}"
                style={isDarkMode() ? 'color: white' : 'color: black'}
                on:click={() => (showSecret = !showSecret)}
                on:keydown={noOp}
                id="toggle-secret"
                role="button"
                tabindex="0"
              />
            </div>
          </div>
        {/if}
      </div>
    </div>
  </div>
  <div
    id="request-status"
    style="display: flex;flex-direction: column;align-items: center;justify-content: center;flex:1"
  >
    {#if requestStatus === 'pending'}
      <div style="display: flex;flex-direction: column;align-items: center;justify-content: center">
        <p style="margin-top: 10px">Uploading...</p>
      </div>
    {:else if requestStatus === 'success'}
      <div style="display: flex;flex-direction: column;align-items: center;justify-content: center">
        <p class="success" style="margin-top: 10px">Upload successful!</p>
      </div>
    {:else if requestStatus === 'error'}
      <div style="display: flex;flex-direction: column;align-items: center;justify-content: center">
        <p class="error" style="margin-top: 10px">Upload failed!</p>
      </div>
    {/if}
  </div>
  <button id="submit-button" disabled on:click|self={_upload}>Submit</button>
</div>

<style>
  h2 {
    font-size: 1.5rem;
    text-align: center;
  }
  label {
    margin-bottom: 0;
  }
  .submit-content {
    display: flex;
    justify-content: space-between;
    flex-direction: column;
    align-items: center;
    height: 100%;
    min-height: 30vh;
    min-width: 30vw;
  }
  @media (max-width: 600px) {
    .submit-content {
      min-width: 90vw;
      min-height: 50vh;
    }
  }
  button {
    background-color: #4caf50;
    border: none;
    color: white;
    padding: 15px 32px;
    text-align: center;
    text-decoration: none;
    display: inline-block;
    font-size: 16px;
    margin: 4px 2px;
    cursor: pointer;
    min-width: 120px;
  }
  button:disabled {
    background-color: #ccc;
    cursor: not-allowed;
  }
  #toggle-secret {
    float: right;
    width: 20px;
    margin-right: 8px;
    margin-top: -42px;
    padding: 4px;
    position: relative;
    z-index: 2;
    cursor: pointer;
  }
</style>
